<?php

namespace STM\Country;

use \Exception;
use STM\StmFactory;

/**
 * Test class for Country.
 * Generated by PHPUnit on 2012-02-13 at 10:59:04.
 * @group team_country
 */
class CountryTest extends \PHPUnit_Framework_TestCase {

    /** @var array(Country) */
    private $all_countries;

    protected function setUp() {
        $this->all_countries = StmFactory::find()->Country->findAll();
    }

    public function testfindById() {        
        foreach ($this->all_countries as $country) {            
            parent::assertInstanceOf('\STM\Country\Country', StmFactory::find()->Country->findById($country->getId()));
        }
        // argument must be numeric
        parent::assertFalse(StmFactory::find()->Country->findById('1 round'));
        parent::assertFalse(StmFactory::find()->Country->findById(null));
        parent::assertFalse(StmFactory::find()->Country->findById(new Exception()));
    }

    public function testFind_all() {
        parent::assertTrue(is_array($this->all_countries));
        foreach ($this->all_countries as $country) {            
            parent::assertInstanceOf('\STM\Country\Country', $country);
        }
    }

    public function testCreate() {
        parent::markTestSkipped('test in CountryValidatorTest::testCheck_create');
    }

    public function testExists_country() {
        foreach ($this->all_countries as $country) {            
            $name = $country->__toString();   
            // case-INsensitive
            parent::assertTrue(Country::exists($name));            
            parent::assertTrue(Country::exists(mb_strtolower($name, 'UTF-8')));
            parent::assertTrue(Country::exists(mb_strtoupper($name, 'UTF-8')));
            parent::assertFalse(Country::exists('_*A*_' . $name));
            // argumetn must be string
            parent::assertFalse(Country::exists($country));
            parent::assertFalse(Country::exists(null));
        }
    }

    public function testDelete() {
        parent::markTestSkipped('only database fail');
    }

    public function testUpdate_country_name() {
        parent::markTestSkipped('test in CountryValidatorTest::testCheck_country_name');
    }

    public function testGet_id() {
        $this->assert_get_to_function('is_int', 'getId');
    }

    public function testTo_array() {
        $this->assert_get_to_function('is_array', 'toArray');
    }

    public function test__toString() {
        $this->assert_get_to_function('is_string', '__toString');
    }

    private function assert_get_to_function($function, $method_name) {
        foreach ($this->all_countries as $country) {
            parent::assertTrue($function($country->$method_name()));
        }
    }
}

?>
